=== debian/changelog ===
cppad (2022.00.00.4-1) unstable; urgency=medium

  * Swizzle debian/watch to git tags
  * New upstream release
  * Bump policy

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 16 Jul 2022 14:59:11 +0100
